using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
using TMPro;

public class GameManager : MonoBehaviour
{
    public static GameManager Instance;
    public UIManger _UIManger;
    public LevelManager levelManager;
    public GameObject world;
    public Raft raft;
    [SerializeField] public double _MaxHP = 3;
    [SerializeField] public int _PlayerSpeed = 3;
    [SerializeField] public int _MindlessHpInterval = 5;
    public Player Player1;
    public Player Player2;
    public Player Player3;
    public Player Player4;
    public float waterResistantSpeed = 1;
    public int RaftHP { get; set; } = 4;
    public int CollisionCount { get; set; } = 0;
    public int RaftRepairCount { get; set; } = 0;
    public int TakeFoodCount { get; set; } = 0;
    public int ShootingCount { get; set; } = 0;

    // Game Ui
    public float GameProgress = 10;
    public int GameCounter { get; set; } = 0;
    private float timer = 0.0f;
    public double GameScore { get; set; } = 0;
    [SerializeField] private int _MaxFood = 10;
    [SerializeField] private int _MaxWood = 10;
    public int _foodNum = 0;
    public int _woodNum = 0;
    public int _woodNum2 = 0;
    public TMP_Text Wood;
    public TMP_Text Wood2;
    public TMP_Text Food;

    public bool gameIsStarted = true;
    private bool isGameOver = false;
    private bool _calledSwitchDay = false;
    private float ft;
    private void Awake()
    {
        if (Instance != null)
        {
            Destroy(gameObject);
        }
        Instance = this;
        _UIManger = GetComponent<UIManger>();
        // DontDestroyOnLoad(this);
    }

    void Start()
    {
        // Start BGM
        // _AudioSource.clip = _AudioClip1;
        // _AudioSource.Play();
        StartCoroutine(time());
        // StopCoroutine(time());
        // _UIManger.MoveToNextWave();
        // InvokeRepeating("UpdateNextWave", 0f, UpdateWaveInterval);

        _UIManger.StartMenuUI.SetActive(true);
        _UIManger.HUD.SetActive(false);
        pauseGame();
        // StartGame();
    }

    void Update()
    {
        Wood.text = _woodNum + "";
        Wood2.text = _woodNum2 + "";
        Food.text = _foodNum + "";
        // _UIManger.MoveToNextWave(UpdateWaveInterval);

        // UpdateNextWave();
        if (!isGameOver)
        {
            CheckPlayerStatus();
        }
    }

    void CheckPlayerStatus()
    {
        if (!Player1.isAlive && !Player2.isAlive)
        {
            isGameOver = true;
            GameOver();
        }
    }
    void UpdateNextWave()
    {
        // Debug.Log("Set Next Day Position : " );
        // _UIManger.SetNextDayPosition();
    }

    IEnumerator time()
    {
        while (true)
        {
            CountScore();
            yield return new WaitForSeconds(1);
        }
    }
    void CountScore()
    {
        GameScore += 1.3;
    }
    private void continueGame()
    {
        Time.timeScale = 1;
    }

    public void pauseGame()
    {
        Time.timeScale = 0;
    }
    public void RestartGame()
    {
        continueGame();
        SceneManager.LoadSceneAsync(SceneManager.GetActiveScene().name);
        // SceneManager.LoadScene(SceneManager.GetActiveScene().name);
    }
    public void QuitGame()
    {
        Application.Quit();
    }

    public void GameWin()
    {
        _UIManger.WinGameUI.SetActive(true);
        pauseGame();
        Debug.Log("Game Ended , player win !!!");
    }

    public void GameOver()
    {
        _UIManger.GameOverUI.SetActive(true);
        pauseGame();
        Debug.Log("Game should be pause!!!");
    }

    public void StartGame()
    {
        continueGame();
        this.gameIsStarted = true;
        levelManager.startLevel();
        _UIManger.StartMenuUI.SetActive(false);
        _UIManger.HUD.SetActive(true);
    }
}