using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Tilemaps;
using UnityEngine.InputSystem;

public class Harpoon : CraftingTable
{
    public TargetAim targetAim;
    public GameObject targetAimStartPoint;
    private int _max_num_food;
    private GameManager gm;

    public bool isAiming = false;

    override public void controlMovement(Vector2 _Movement)
    {
        this.ControlTargetAim(_Movement);
    }

    override public void controlAction(InputActionPhase action)
    {
        base.controlAction(action);
        switch (action)
        {
            case InputActionPhase.Started:
                this.StartAiming();
                break;
            case InputActionPhase.Performed:
                this.OnAiming();
                break;
            case InputActionPhase.Canceled:
                this.controllingPlayer = null;
                this.FinishAiming();
                break;
        }
    }

    public void ControlTargetAim(Vector2 _Movement)
    {
        Vector3 v3 = _Movement * targetAim._Speed;
        targetAim.transform.position = targetAim.transform.position + v3;
    }

    public void StartAiming()
    {
        this.isAiming = true;
        this.targetAim.gameObject.SetActive(true);
        this.targetAim.transform.position = this.targetAimStartPoint.transform.position;
    }

    public void OnAiming()
    {

    }

    public void FinishAiming()
    {
        Debug.Log("finish aiming");
        this.targetAim.emitRaycast();
        this.ResetTable();
    }

    //public void CancelAiming()
    //{
    //    Debug.Log("cancel aiming");
    //    this.ResetTable();
    //}

    public void ResetTable()
    {
        this.targetAim.gameObject.SetActive(false);
        this.isAiming = false;
    }
}
