using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;

public class CraftingTable: MonoBehaviour
{
    // Action Controller
    public Player controllingPlayer;

    public Sprite defaultSprite;
    public Sprite highlightSprite;
    private SpriteRenderer spriteRenderer;
    public AudioManager am;

    private void Awake()
    {
        this.am = GameObject.Find("GameManager").GetComponent<AudioManager>();
        this.spriteRenderer = this.GetComponent<SpriteRenderer>();
        this.defaultSprite = this.spriteRenderer.sprite;
    }

    public virtual void controlMovement(Vector2 _Movement) { }
    
    public virtual void controlAction(InputActionPhase action) {
        
        switch (action)
        {
            case InputActionPhase.Started:
                this.freeze(true);
                break;
            case InputActionPhase.Performed:
                break;
            case InputActionPhase.Canceled:
                this.freeze(false);
                // this.controllingPlayer = null;
                break;
        }
    }

    public void startControl(Player player) {
        this.controllingPlayer = player;
    }

    public void cancelControl() {
        this.controllingPlayer = null;
    }

    public void freeze(bool isTrigger)
    {
        if (this.controllingPlayer != null)
        {
            this.controllingPlayer.freeze(isTrigger);
        }
    }

    public void highlight(bool isTouching)
    {
        if (this.defaultSprite != null && this.highlightSprite != null)
        {
            this.spriteRenderer.sprite = isTouching ? this.highlightSprite : this.defaultSprite;

        }
        
    }

}
