﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;

public class Rudder : CraftingTable
{

    public Raft raft;
    public Animator animator;

    // private AudioManager am;

    override public void controlMovement(Vector2 _Movement)
    {
        this.controlRaft(_Movement);
    }

    override public void controlAction(InputActionPhase action)
    {
        base.controlAction(action);
        switch (action)
        {
            case InputActionPhase.Started:
                animator.SetBool("IsActive", true);
                am.PlayAudio(AudioManager.AudioType.RudderAudio);
                break;
            case InputActionPhase.Performed:
                break;
            case InputActionPhase.Canceled:
                animator.SetBool("IsActive", false);
                am.StopAudio();
                // am.StopAudio();
                // this.controllingPlayer = null;
                break;
        }
    }

    public void controlRaft(Vector2 _Movement)
    {
        //Debug.Log("controlling the raft");
        Vector3 v3 = _Movement * raft._Speed;
        raft.transform.position = raft.transform.position + v3;
    }
}
