using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;

public class FoodBox : CraftingTable
{
    private int _max_num_food;
    private GameManager gm;

    public int currentFoodNum = 0;

    public static float maxEatingSeconds = 5;
    public float eatingTimeRemaining = 5; // 5s
    public bool isEating = false;

    override public void controlMovement(Vector2 _Movement)
    {
        //this.controllingPlayer.GetComponent<Rigidbody2D>().velocity = _Movement * this.controllingPlayer.movementSpeed;
        //this.CancelEating();
    }

    override public void controlAction(InputActionPhase action)
    {
        base.controlAction(action);
        switch (action)
        {
            case InputActionPhase.Started:
                this.StartEating();
                AudioManager.Instance.PlayAudio(AudioManager.AudioType.EatAudio);
                break;
            case InputActionPhase.Performed:
                this.OnEating();
                break;
            case InputActionPhase.Canceled:
                // this.controllingPlayer = null;
                AudioManager.Instance.StopAudio();
                this.CancelEating();
                break;
        }
    }

    public void StartEating()
    {
        if (currentFoodNum > 0)
        {
            Debug.Log("start eating");
            this.isEating = true;
        }
    }

    public void OnEating()
    {
    }

    public void FinishEating()
    {
        Debug.Log("finish eating");
        // this.currentFoodNum--;
        this.controllingPlayer.HP++;
        GameManager.Instance._foodNum--;
        this.controllingPlayer.GetPlayerStatus();
        this.ResetTable();
    }

    public void CancelEating()
    {
        Debug.Log("cancel eating");

        this.ResetTable();
    }

    public void AddFood()
    {
        this.currentFoodNum++;
    }

    public void ResetTable()
    {

        if (!this.isEating) { return; }
        this.isEating = false;
        this.eatingTimeRemaining = maxEatingSeconds;
        this.freeze(false);
        // Animation end
        this.controllingPlayer.FinishProgress();
        this.controllingPlayer = null;
    }

    private void Update()
    {
        if (this.isEating)
        {

            if (this.eatingTimeRemaining > 0)
            {
                this.controllingPlayer.StartProgress(this.eatingTimeRemaining -= Time.deltaTime, maxEatingSeconds);
                this.eatingTimeRemaining -= Time.deltaTime;
            }
            else
            {
                this.FinishEating();
            }
        }
    }
}
